
var helpstr = "In general, this plugin operates on the parameters of the webpage you are curriently browsing and predefined parameters in ConQuery Config Dialog. When you execute ConQuery menu entry, the engine substitutes user variables in predefined URL template with corresponding page data. Available variables are: \n [:selection] - selected text;\n [:url] - page URL;\n [:host] - only HOST from page URL;\n [:prompt] - prompt for input text.\n You may combine variables in template. If there is [:selection] and no selected text on a page, the ConQuery will ask you to input one. You may also tune up query before execution: hold Ctrl key while executing menu entry.\n    All queries organized in two groups: \n - list in ''ConQuery Config'' dialog under the My ConQueries tab;\n - entries under the ''Query to...'' context menu item.\n You may execute queries from bouth places. All manipulations with entries in Config menu performs with mouse right-click. The property ''Show?'' indicates whether query is shown in context menu group.\n The Config Dialog is also accessible via doubleclick on ''Query to...'' browser context menu entry.\n Note that this is alpha version, so any suggestions will be appreciated.\n Happy serfing!\n McV.";
var EntryList;
var EntryDesc;
var repEntryList;
var ShowBlocked = false;

function init(){
  EntryList    = document.getElementById('EntryList');
  EntryDesc    = document.getElementById('Desc');
  repEntryList = document.getElementById('repEntryList');
	repEntryDesc = document.getElementById('repDesc');
	PlugsDirBox  = document.getElementById('plugsdir');
	ReadOnlyCqr  = document.getElementById('cqonly');
	ShowBlocked  = document.getElementById('showblocked').checked;
	//PlugsDirBox.value = GetMycroftDir();
	//document.getElementById('help').value = helpstr;
  
  ////moved to main.js
  //prfs_LoadMain();
  
	plg_QuickLoadAll();
  prfs_UpdateEntries();

	window.setTimeout('initWithDelay();', 0);
  //window.sizeToContent();
}

function initWithDelay(){
  fillprefstab();
  initList(EntryList, EntryHash);
}

function plg_ReloadTree(){
	plg_QuickLoadAll();
  prfs_UpdateEntries();
  initList(EntryList, EntryHash);
}

function plg_block(really){
  if (!EntryList.selectedItem) return;
  EntryHash[EntryList.selectedItem.getAttribute('value')].blocked = really;
  prfs_SaveEntries();
  plg_ReloadTree();
}

function fillprefstab() {
	document.getElementById('prfs_plugsdir').value = PlugsDir;
	document.getElementById('enhotmenu').checked = UseHotMenu;
	document.getElementById('loadinbg').checked = LoadTabsInBg;
}



function initList(list, srcHash){
  ShowBlocked  = document.getElementById('showblocked').checked;
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var cellcheck;
  var entries = srcHash._Items();

  var listcols =  document.createElement('listcols');
  var listcol1 =  document.createElement('listcol');
  var listcol2 =  document.createElement('listcol');
  var listcol3 =  document.createElement('listcol');
  var splitter = document.createElement('splitter');
  var listhead = document.createElement('listhead');
  var listheader1 =  document.createElement('listheader');
  var listheader2 =  document.createElement('listheader');
  var listheader3 =  document.createElement('listheader');
  splitter.setAttribute("class", "tree-splitter");
  listcol1.setAttribute("flex", "16");
  listcol2.setAttribute("flex", "1");
  listcol2.setAttribute("style", "width: 4em;");
  listcol3.setAttribute("flex", "1");
  listcol3.setAttribute("style", "width: 5em;");
  listcols.appendChild(listcol1);
    if (srcHash == EntryHash){
      listcols.appendChild(splitter);
      listcols.appendChild(listcol2);
      listcols.appendChild(listcol3);
    }
  listheader1.setAttribute('label', "Queries");
  listheader2.setAttribute('label', "Show?");
  listheader3.setAttribute('label', "Show if?");
  listhead.appendChild(listheader1);
    if (srcHash == EntryHash){
      listhead.appendChild(listheader2);
      listhead.appendChild(listheader3);
    }
  list.appendChild(listcols);
  list.appendChild(listhead);
  
  for (i=0; i<entries.length; i++){
		if ((!ShowBlocked) && (entries[i].blocked)) continue;
			  if (list.id == "EntryList"){
			  	ondk  = 'if (isValidLeftClick(event,"listitem")) ExecQuery(event.ctrlKey, "'+entries[i].eId+'");';
			  	onsel = 'onSelect(EntryHash, EntryDesc, '+entries[i].eId+')'
			  } else if(list.id == "repEntryList"){
			  	ondk='if (isValidLeftClick(event,"listcell")) CopyEntry(repEntryHash, '+entries[i].eId+', EntryHash, EntryList);';
			  	onsel = 'onSelect(repEntryHash, repEntryDesc, '+entries[i].eId+')';
			  }

    item = document.createElement('listitem');
    item.setAttribute('value', entries[i].eId);
    item.setAttribute('allowevents', true);
    //if (entries[i].showif) item.setAttribute('style', "color: #408080");
    if (entries[i].blocked) item.setAttribute('style', "color: #828282");
		//item.setAttribute('ondblclick', ondk);
		
    celldata = document.createElement('listcell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('ondblclick', ondk);
    item.appendChild(celldata);
    if (srcHash == EntryHash){
      cellcheck = document.createElement('listcell');
      check = document.createElement('checkbox');
      check.setAttribute('id', entries[i].eId);
      check.setAttribute('oncommand', "UpdateStatus(this);");
      check.setAttribute('checked', entries[i].Context);
      cellcheck.appendChild(check);
      item.appendChild(cellcheck);
      if (entries[i].showif){
        cellshowif = document.createElement('listcell');
        cellshowif.setAttribute('label', "yes");
        item.appendChild(cellshowif);
      }
    }
    list.appendChild(item);
  }
}

function onSelect(){
	var desctext = "";
	eId = EntryList.selectedItem.getAttribute('value');
	item = EntryHash._Item(eId);
	if (!item.Inputs){
		item = plg_ReadData(item.filepath);
    item.Context = EntryHash[eId].Context;
    item.lastmatch = EntryHash[eId].lastmatch;
		EntryHash._AddEntryObj(item);
	}
	
	desctext = item.Title + ":\n" +
  	item.Desc + "\n" +
  	item.filepath;
	if (item.showif) desctext += "\nWill be shown if pattern: " + item.showif + " found in: " + item.sitarget;
	desctext += "\n\n This query has following inputs:";
	desctext += "\n------------------------------------\n";
  for (i in item.Inputs){
    desctext += i+" = "+item.Inputs[i].value +"\n";
    if (item.Inputs[i].list){
    	for (v in item.Inputs[i].list) desctext += "   or: "+item.Inputs[i].list[v].value + "\n";
    }
  }
	EntryDesc.value = desctext;
}

function UpdateStatus(check){
  EntryHash[check.id].Context = check.checked;
	prfs_SaveEntries();
}

function ImportPlugins(){
	//if (!item) item=EntryList.selectedItem.getAttribute('value');
	//if (item=="add") item="";
	repEntryHash._Clear();
	window.openDialog("chrome://conquery/content/mcparser.xul","_blank",
	"centerscreen,chrome,modal,resizable=yes", document.getElementById("plugtype").selectedItem.id);
}

function ExecQuery(ctrl, id){
try{
  window.opener.top.ConfigLastWillId = EntryList.selectedItem.getAttribute('value');
  window.opener.top.ConfigLastWillCtrl = ctrl;
  window.close();
}catch(er){cqerr(er, "ExecQuery sub")}
}


function isValidLeftClick(aEvent, aName){
  return (aEvent.button == 0 && aEvent.originalTarget.localName == aName);
}
